﻿using System;
using System.Collections.Generic;
using System.Linq;
using Syncfusion.EJ.Export;
using Syncfusion.JavaScript;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using System.ComponentModel.DataAnnotations;
using System.Collections;
using Syncfusion.JavaScript.DataSources;
using Syncfusion.JavaScript.Models;
using Newtonsoft.Json;
using Syncfusion.XlsIO;

namespace WebApplication8.Controllers
{
    public class HomeController : Controller
    {
        public static List<Orders> order = new List<Orders>();
        public static List<Orders> order2 = new List<Orders>();
        public IActionResult Index()
        {

            var data = GetData();
            ViewBag.dataSource = data;
            ViewBag.dataSource1 = order2;
            return View();

        }
        public ActionResult ExportToExcel(string GridModel)
        {
            ExcelExport exp = new ExcelExport();
            var DataSource =  GetData();
            GridProperties gridProp = ConvertGridObject(GridModel);
            GridExcelExport excelExp = new GridExcelExport();
            excelExp.FileName = "Export.xlsx";
            excelExp.Excelversion = ExcelVersion.Excel2016;
            excelExp.Theme = "flat-saffron";
            return exp.Export(gridProp, DataSource, excelExp);
        }

        public ActionResult ExportToPdf(string GridModel)
        {
            PdfExport exp = new PdfExport();
            var DataSource = GetData();
            GridProperties gridProp = ConvertGridObject(GridModel);
            GridPdfExport pdfExp = new GridPdfExport();
            pdfExp.FileName = "Export.pdf";
            pdfExp.Theme = "flat-saffron";
            return exp.Export(gridProp, DataSource, pdfExp);
        }
        private GridProperties ConvertGridObject(string gridProperty)
        {
            GridProperties gridProp = new GridProperties();
            gridProp = (GridProperties)JsonConvert.DeserializeObject(gridProperty, typeof(GridProperties));
            return gridProp;
        }

        public List<Orders> GetData()
        {
            int code = 10000;
            for (int i = 1; i < 10; i++)
            {
                order.Add(new Orders(code + 1, "ALFKI", i + 1, 2.3 * i, new DateTime(1991, 05, 15), "UK"));
                order.Add(new Orders(code + 2, "ANATR", i + 2, 3.3, new DateTime(1990, 04, 04), "Madrid"));
                order.Add(new Orders(code + 3, "ANTON", i + 1, 4.3 * i, new DateTime(1957, 11, 30), "US" ));
                order.Add(new Orders(code + 4, "BLONP", i + 3, 5.3 * i, new DateTime(1930, 10, 22), "Marseille"));
                order.Add(new Orders(code + 5, "BOLID", i + 4, 6.3, new DateTime(1953, 02, 18), "Tsawassen"));
                code += 5;
            }
            return order;
        }
        public ActionResult RowDropHandler(List<Orders> added, List<Orders> deleted)
        {

            //TO do here when droping
            return Json(added);
        }

        public class Orders
        {
            public Orders()
            {

            }
            public Orders(long OrderId, string CustomerId, int? EmployeeId, double Freight, DateTime OrderDate, string ShipCity)
            {
                this.OrderID = OrderId;
                this.CustomerID = CustomerId;
                this.EmployeeID = EmployeeId;
                this.Freight = Freight;
                this.OrderDate = OrderDate;
                this.ShipCity = ShipCity;
            }

            [Range(0, int.MaxValue, ErrorMessage = "OrderID must be greater than 0.")]
            public long OrderID { get; set; }
            [StringLength(5, ErrorMessage = "CustomerID must be 5 characters.")]
            public string CustomerID { get; set; }
            
            public int? EmployeeID { get; set; }
            [Display(Name = "Freight column")]
            public double Freight { get; set; }
            public DateTime OrderDate { get; set; }
            public string ShipCity { get; set; }
        }




        public IActionResult About()
        {
            ViewData["Message"] = "Your application description page.";

            return View();
        }

        public IActionResult Contact()
        {
            ViewData["Message"] = "Your contact page.";

            return View();
        }

        public IActionResult Error()
        {
            return View();
        }
    }
}
